package com.muyu.data.processing.controller;


import com.muyu.common.kafka.constants.KafkaConstants;
import com.muyu.data.processing.domain.req.TestReq;
import com.muyu.data.processing.domain.resp.TestResp;
import com.muyu.data.processing.strategy.root.RootStrategy;
import jakarta.annotation.Resource;
import org.apache.kafka.clients.producer.KafkaProducer;
import org.apache.kafka.clients.producer.ProducerRecord;
import org.springframework.web.bind.annotation.*;
import lombok.extern.slf4j.Slf4j;

/**
 * 测试控制层
 * @Author: 胡杨
 * @Name: Test
 * @Description:
 * @CreatedDate: 2024/9/27 上午10:54
 * @FilePath: com.muyu.data.processing.controller
 */
@Slf4j
@RestController
@RequestMapping("/Test")
public class TestController {
    @Resource
    private KafkaProducer<String,String> kafkaProducer;

    @GetMapping("/testKafka")
    public void sendMsg(@RequestParam("msg") String msg) {
        try {
            // 测试数据
            String jsonString = """
                    [{
                        "key": "vin",
                        "label": "VIN码",
                        "type": "String",
                        "value": "vin131413534474"
                    },{
                        "key": "timestamp",
                        "label": "时间戳",
                        "type": "long",
                        "value": 1727534036893L
                    },{
                        "key": "latitude",
                        "label": "纬度",
                        "type": "float",
                        "value": 66.898F
                    },{
                        "key": "longitude",
                        "label": "经度",
                        "type": "float",
                        "value": 99.124F
                    }]""";
            ProducerRecord<String, String> producerRecord = new ProducerRecord<>(KafkaConstants.KafkaTopic, jsonString);
            kafkaProducer.send(producerRecord);
            System.out.println("同步消息发送成功: " + jsonString);
        } catch (Exception e) {
            e.printStackTrace();
            System.out.println("同步消息发送失败");
        }
    }


//    @Resource
//    private RootStrategy rootStrategy;
//
//    @PostMapping("/testStrategy")
//    public TestResp testStrategy(@RequestBody TestReq testReq) {
//        return rootStrategy.applyStrategy(testReq);
//    }
}
